/**
 * RMIGaugeConsumer.java
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/RMI/RMIGaugeConsumer.java,v 1.4 2002/01/31 16:39:04 schmerl Exp $
 * $Log: RMIGaugeConsumer.java,v $
 * Revision 1.4  2002/01/31 16:39:04  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.RMI;

import java.util.Vector;
import java.util.Enumeration;

import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
import edu.cmu.cs.able.gaugeInfrastructure.RMI.Events.*;
/**
 * A stub implementation of the a gauge consumer that listens to
 * rmi gauges.
 * @author      Hong Yan
 * @author      Bradley Schmerl
 * @version     1.0
 * @since       JDK1.3.1
 */
public class RMIGaugeConsumer implements GaugeConsumer, java.io.Serializable
{
    /** The reporting bus that gauges report through.
     */    
    protected RMIGaugeReportingBus gaugeBus;
    protected RMIGaugeManagerHandle gaugeMgr = null;
        
    public String gaugeConsumerUID;
    public String gaugeConsumerHost;
    public String busHost;
    
    //protected GaugeConsumerGUI theGaugeConsumerGUI;   

    /**
    * Constructor of RMIGaugeConsumer
    */
    public RMIGaugeConsumer(String host)
    {
        super();
        try {
            gaugeConsumerUID = Global.generateUniqueID();
            busHost = host;
            gaugeBus = new RMIGaugeReportingBus (host);
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }



    /** Called when a value is reported
     * @param gauge The gauge reporting the value
     * @param valueName The name of the value
     * @param propertyName The property name of the value     
     * @param value The content of the value     
     */    
    public void onReportValue(GaugeControl gauge, String valueName, String propertyName, String value)
    {
    }
    
    
    /** Called when multiple values are reported
     * @param gauge The gauge reporting the values
     * @param values The values     
     */    
    public void onReportMultipleValues(GaugeControl gauge, GaugeValueVector values)
    {
    }
    
    /** Called when a configured event is reported
     * @param gauge The gauge reporting the event
     * @param configParams The configuration parameters
     */    
    public void onReportConfigured(GaugeControl gauge, StringPairVector configParams)
    {
    }
    
    
    /** Called when a deleted event is reported
     * @param gauge The gauge reporting the event
     */    
    public void onReportDeleted(GaugeControl gauge)
    {
    }

    /** Called when a created event is reported
     * @param gauge The gauge reporting the event
     */    
    public void onReportCreated(GaugeControl gauge)
    {
    }
}
