/**
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/RMI/RMIGaugeHandle.java,v 1.3 2002/01/31 16:39:04 schmerl Exp $
 * $Log: RMIGaugeHandle.java,v $
 * Revision 1.3  2002/01/31 16:39:04  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.RMI;

import java.util.Vector;
import java.util.Enumeration;
import java.rmi.*;

import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
/**
 * RMIGaugeHandle is a proxy gauge that acts as if it is the actual gauge
 * it refers to. It is used to hide the details of how to maintain the
 * peer-to-peer interaction between a local caller (or client) and a
 * remote callee (or server).
 * @author      Hong Yan
 * @author      Bradley Schmerl
 * @version     1.0
 * @since       JDK1.3.1
 **/
public class RMIGaugeHandle implements GaugeControl, java.io.Serializable
{
    protected RMIGaugeHandleInt gaugeHandle;
    
    /** Creates new RMIGauge */
    public RMIGaugeHandle(String host) {
        try {
            gaugeHandle = (RMIGaugeHandleInt)connectTo(host);
        }
        catch (Exception e) {} 
    }

    public GaugeID getGaugeID() {
        try {
            return gaugeHandle.getGaugeID();
        }
        catch (Exception e) {} 
        return null;
    }
    
    public StringPairVector getConfigParams() {
        try {
            return gaugeHandle.getConfigParams();
        }
        catch (Exception e) {} 
        return null;
    }

    public int getConfigParamsSize() {
        try {
            return gaugeHandle.getConfigParamsSize();
        }
        catch (Exception e) {
            e.printStackTrace();
        } 
        return -1;
    }

    public StringPairVector getSetupParams() {
        try {
            return gaugeHandle.getSetupParams();
        }
        catch (Exception e) {} 
        return null;
    }

    public int getSetupParamsSize() {
        try {
            return gaugeHandle.getSetupParamsSize();
        }
        catch (Exception e) {
            e.printStackTrace();
        } 
        return -1;
    }
    
    // These methods must be overridden by particular gauges
    
   
    public boolean configure(StringPairVector configParams) {
        try {
            return gaugeHandle.configure(configParams);
        }
        catch (Exception e) {} 
        return false;
    }
    
    public boolean queryAllValues(GaugeValueVector values) {
        try {
            return gaugeHandle.queryAllValues(values);
        }
        catch (Exception e) {} 
        return false;
    }
    
    public boolean queryState(StringPairVector setupParams, StringPairVector configParams, StringPairVector mappings) {
        try {
            return gaugeHandle.queryState(setupParams, configParams, mappings);
        }
        catch (Exception e) {} 
        return false;
    }
    
    public String queryValue(String valueName) {
        try {
            return gaugeHandle.queryValue(valueName);
        }
        catch (Exception e) {} 
        return null;
    }

    private java.rmi.Remote connectTo(String host) {
        try {
            RMIGaugeHandleInt gh = (RMIGaugeHandleInt)Naming.lookup("rmi://"+host+"/Gauge");
                return gh;
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
}
